
import sys

lineSep = java.lang.System.getProperty('line.separator')


def getWASHome(cell, node):
	varMap = AdminConfig.getid("/Cell:" + cell + "/Node:" + node + "/VariableMap:/")
	entries = AdminConfig.list("VariableSubstitutionEntry", varMap)
	eList = entries.split(lineSep)
	for entry in eList:
		name =  AdminConfig.showAttribute(entry, "symbolicName")
		if name == "WAS_INSTALL_ROOT":
			value = AdminConfig.showAttribute(entry, "value")
			return value
	#failover
	return java.lang.System.getenv('WAS_HOME')



def getFileSep(node): 
	os = AdminTask.getNodePlatformOS("-nodeName " + node)
	if os == 'windows':
		return '\\'
	else:
		return '/'





def uninstallScheduler(cell, node, server):
	try:
		print "Uninstalling LongRunningScheduler.ear"

		#get configuration ID for LongRunningScheduler
		configId = AdminConfig.getid("/Deployment:LongRunningScheduler/")   		

		#can not find config id
		if configId == None or configId == "":
			print "Scheduler is not installed. Still try anyway."
			AdminApp.uninstall('LongRunningScheduler')
			return 1
		else:	
			AdminApp.uninstall('LongRunningScheduler')
			return 1		
	except:
		print "Exception occurred during uninstallScheduler(" + cell +", " + node + ", " + server + "):", sys.exc_info()
		return 1
	return 1

def uninstallPGCProxy(cell, node, server):
	try:
		print "Uninstalling PGCProxyController.ear"
		
		#get configuration ID for PGCProxyController
		configId = AdminConfig.getid("/Deployment:PGCProxyController/")   		

		#can not find config id
		if configId == None or configId == "":
			print "Endpoint is not installed. Still try anyway."
			AdminApp.uninstall('PGCProxyController')
		else:	
			AdminApp.uninstall('PGCProxyController')
			return 1		
	except:
		print "Exception occurred during uninstallPGCProxy(" + cell +", " + node + ", " + server + "):", sys.exc_info()
		return 1
	return 1

def uninstallEndpoint(cell, node, server):
	try:
		print "Uninstalling PGCController.ear"
		
		#get configuration ID for PGCController
		configId = AdminConfig.getid("/Deployment:PGCController/")   		

		#can not find config id
		if configId == None or configId == "":
			print "Endpoint is not installed. Still try anyway."
			AdminApp.uninstall('PGCController')
		else:	
			AdminApp.uninstall('PGCController')
			return 1		
	except:
		print "Exception occurred during uninstallEndpoint(" + cell +", " + node + ", " + server + "):", sys.exc_info()
		return 1
	return 1


#------------------------------------------------------------------------------
# Main entry point
#------------------------------------------------------------------------------

cell = None
node = None
server = None


# set cell and node name 
cellObj = AdminConfig.list("Cell")
cell = AdminConfig.showAttribute(cellObj, "name")

nodeObj = AdminConfig.list("Node", cellObj)
node = AdminConfig.showAttribute(nodeObj,"name")

#this is UTE, so server is always server1
server = "server1"

if cell == None:
	print "Please specify a cell with the \'-cell\' option when in disconnected mode"
elif node == None:
	print "Please specify a node with the \'-node\' option when in disconnected mode"
elif server == None:
	print "Please specify a server with the \'-server\' option."
else:
	print "Cell:  " + cell + ", Node:  " + node + ", Server:  " + server
	
if server != None and cell != None and node != None:
	retVal = uninstallScheduler(cell, node, server)
	if retVal == 1:
		retVal = uninstallEndpoint(cell, node, server)
        if retVal == 1:
            retVal = uninstallPGCProxy(cell, node, server)
        else:
            print "Skipping PGC Proxy Controller uninstallation"
	else:
		print "Skipping Endpoint and PGCProxyController Uninstall"
	if retVal == 1:
		AdminConfig.save()
	else:
		print "Skipping Config Save"
